Index: LMDZ4/trunk/libf/phylmd/pbl_surface_mod.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/pbl_surface_mod.F90	(revision 993)
+++ LMDZ4/trunk/libf/phylmd/pbl_surface_mod.F90	(revision 996)
@@ -13,5 +13,5 @@
   USE mod_phys_lmdz_para,  ONLY : mpi_size
   USE ioipsl
-  USE surface_data,        ONLY : ocean, ok_veget
+  USE surface_data,        ONLY : type_ocean, ok_veget
   USE surf_land_mod,       ONLY : surf_land
   USE surf_landice_mod,    ONLY : surf_landice
@@ -151,7 +151,7 @@
 !****************************************************************************************
 
-    IF (ocean /= 'slab  ' .AND. ocean /= 'force ' .AND. ocean /= 'couple') THEN
+    IF (type_ocean /= 'slab  ' .AND. type_ocean /= 'force ' .AND. type_ocean /= 'couple') THEN
       WRITE(lunout,*)' *** Warning ***'
-      WRITE(lunout,*)'Option couplage pour l''ocean = ', ocean
+      WRITE(lunout,*)'Option couplage pour l''ocean = ', type_ocean
       abort_message='option pour l''ocean non valable'
       CALL abort_gcm(modname,abort_message,1)
@@ -187,5 +187,5 @@
        zxtsol,    zxfluxlat, zt2m,     qsat2m,        &
        d_t,       d_q,       d_u,      d_v,           & 
-       zcoefh,    pctsrf_new,                         &
+       zcoefh,    slab_wfbils,                        &
        qsol_d,    zq2m,      s_pblh,   s_plcl,        &
        s_capCL,   s_oliqCL,  s_cteiCL, s_pblT,        &
@@ -299,4 +299,5 @@
     REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: u10m    ! u speed at 10m
     REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: v10m    ! v speed at 10m
+    REAL, DIMENSION(klon, klev+1, nbsrf), INTENT(INOUT) :: tke 
 
 ! Output variables
@@ -321,7 +322,7 @@
     REAL, DIMENSION(klon, klev),  INTENT(OUT)       :: d_v        ! change in v speed
     REAL, DIMENSION(klon, klev),  INTENT(OUT)       :: zcoefh     ! coef for turbulent diffusion of T and Q, mean for each grid point
-    REAL, DIMENSION(klon, nbsrf), INTENT(OUT)       :: pctsrf_new ! new sub-surface fraction
 
 ! Output only for diagnostics
+    REAL, DIMENSION(klon),        INTENT(OUT)       :: slab_wfbils! heat balance at surface only for slab at ocean points
     REAL, DIMENSION(klon),        INTENT(OUT)       :: qsol_d     ! water height in the soil (mm)
     REAL, DIMENSION(klon),        INTENT(OUT)       :: zq2m       ! water vapour at 2m, mean for each grid point
@@ -367,7 +368,4 @@
     REAL, DIMENSION(klon, nbsrf),INTENT(OUT)        :: q2m        ! water vapour at 2 meter height
     REAL, DIMENSION(klon, klev, nbsrf), INTENT(OUT) :: flux_q     ! water vapour flux(latent flux) (kg/m**2/s)
-
-! Input/output
-    REAL, DIMENSION(klon, klev+1, nbsrf), INTENT(INOUT) :: tke
 
 
@@ -431,5 +429,4 @@
     REAL, DIMENSION(klon)              :: ypsref
     REAL, DIMENSION(klon)              :: yevap, ytsurf_new, yalb1_new, yalb2_new
-    REAL, DIMENSION(klon)              :: pctsrf_nsrf
     REAL, DIMENSION(klon)              :: ztsol
     REAL, DIMENSION(klon)              :: alb_m  ! mean albedo for whole SW interval
@@ -446,5 +443,4 @@
     REAL, DIMENSION(klon,klev+1)       :: ytke
     REAL, DIMENSION(klon,nsoilmx)      :: ytsoil
-    REAL, DIMENSION(klon,nbsrf)        :: pctsrf_pot
     CHARACTER(len=80)                  :: abort_message
     CHARACTER(len=20)                  :: modname = 'pbl_surface'
@@ -470,16 +466,10 @@
     REAL, DIMENSION(klon,nbsrf)        :: trmb2        ! inhibition
     REAL, DIMENSION(klon,nbsrf)        :: trmb3        ! point Omega
-    REAL, DIMENSION(klon,nbsrf)        :: zx_rh2m, zx_qsat2m
-    REAL, DIMENSION(klon,nbsrf)        :: zx_qs1, zx_t1
-    REAL, DIMENSION(klon,nbsrf)        :: zdelta1, zcor1
+    REAL, DIMENSION(klon,nbsrf)        :: zx_t1
     REAL, DIMENSION(klon, nbsrf)       :: alb          ! mean albedo for whole SW interval
     REAL, DIMENSION(klon)              :: ylwdown      ! jg : temporary (ysollwdown)
 
-
-!jg+ temporary test
-    REAL, DIMENSION(klon,klev)         :: y_flux_u_old, y_flux_v_old
-    REAL, DIMENSION(klon,klev)         :: y_d_u_old, y_d_v_old
-!jg-
-    
+    REAL                               :: zx_qs1, zcor1, zdelta1 
+
 !****************************************************************************************
 ! Declarations specifiques pour le 1D. A reprendre 
@@ -558,5 +548,5 @@
     yv1 = 0.0     ; ypaprs = 0.0     ; ypplay = 0.0
     ydelp = 0.0   ; yu = 0.0         ; yv = 0.0        ; yt = 0.0         
-    yq = 0.0      ; pctsrf_new = 0.0 ; y_dflux_t = 0.0 ; y_dflux_q = 0.0 
+    yq = 0.0      ; y_dflux_t = 0.0  ; y_dflux_q = 0.0 
     yrugoro = 0.0 ; yu10mx = 0.0     ; yu10my = 0.0    ; ywindsp = 0.0   
     d_ts = 0.0    ; yfluxlat=0.0     ; flux_t = 0.0    ; flux_q = 0.0     
@@ -661,14 +651,8 @@
 ! 4) Loop over different surfaces
 !
-! All points with a possibility of the current surface are used. This is done
-! to allow the sea-ice to appear or disappear. It is considered here that the 
-! entier domaine of the ocean possibly can contain sea-ice.
+! Only points containing a fraction of the sub surface will be threated.
 ! 
 !****************************************************************************************
-
-    pctsrf_pot = pctsrf
-    pctsrf_pot(:,is_oce) = 1. - zmasq(:)
-    pctsrf_pot(:,is_sic) = 1. - zmasq(:)
-      
+    
     loop_nbsrf: DO nsrf = 1, nbsrf
 
@@ -677,5 +661,5 @@
        knon  = 0
        DO i = 1, klon
-          IF (pctsrf_pot(i,nsrf).GT.epsfra) THEN
+          IF (pctsrf(i,nsrf) > 0.) THEN
              knon = knon + 1
              ni(knon) = i
@@ -730,6 +714,6 @@
              ypaprs(j,k) = paprs(i,k)
              ypplay(j,k) = pplay(i,k)
-             ydelp(j,k) = delp(i,k)
-             ytke(j,k)=tke(i,k,nsrf)
+             ydelp(j,k)  = delp(i,k)
+             ytke(j,k)   = tke(i,k,nsrf)
              yu(j,k) = u(i,k)
              yv(j,k) = v(i,k)
@@ -762,5 +746,5 @@
        CALL coef_diff_turb(dtime, nsrf, knon, ni,  &
             ypaprs, ypplay, yu, yv, yq, yt, yts, yrugos, yqsurf,  &
-            ycoefm, ycoefh,ytke)
+            ycoefm, ycoefh, ytke)
        
 !****************************************************************************************
@@ -817,5 +801,5 @@
                ysnow, yqsol, yagesno, ytsoil, &
                yz0_new, yalb1_new, yalb2_new, yevap, yfluxsens, yfluxlat, &
-               yqsurf, ytsurf_new, y_dflux_t, y_dflux_q, pctsrf_nsrf, &
+               yqsurf, ytsurf_new, y_dflux_t, y_dflux_q, &
                ylwdown)
      
@@ -828,9 +812,9 @@
                ysnow, yqsurf, yqsol, yagesno, &
                ytsoil, yz0_new, yalb1_new, yalb2_new, yevap, yfluxsens, yfluxlat, &
-               ytsurf_new, y_dflux_t, y_dflux_q, pctsrf_nsrf)
+               ytsurf_new, y_dflux_t, y_dflux_q)
           
        CASE(is_oce)
           CALL surf_ocean(rlon, rlat, ysolsw, ysollw, yalb1, &
-               yrugos, ywindsp, rmu0, yfder, &
+               yrugos, ywindsp, rmu0, yfder, yts, &
                itap, dtime, jour, knon, ni, &
                debut, &
@@ -840,5 +824,5 @@
                ysnow, yqsurf, yagesno, &
                yz0_new, yalb1_new, yalb2_new, yevap, yfluxsens, yfluxlat, &
-               ytsurf_new, y_dflux_t, y_dflux_q, pctsrf_nsrf)
+               ytsurf_new, y_dflux_t, y_dflux_q, slab_wfbils)
           
        CASE(is_sic)
@@ -852,5 +836,5 @@
                ysnow, yqsurf, yqsol, yagesno, ytsoil, &
                yz0_new, yalb1_new, yalb2_new, yevap, yfluxsens, yfluxlat, &
-               ytsurf_new, y_dflux_t, y_dflux_q, pctsrf_nsrf)
+               ytsurf_new, y_dflux_t, y_dflux_q)
           
 
@@ -861,9 +845,4 @@
        END SELECT
 
-!****************************************************************************************
-! Save the fraction of this sub-surface 
-!
-!****************************************************************************************
-       pctsrf_new(:,nsrf) = pctsrf_nsrf(:)
 
 !****************************************************************************************
@@ -882,6 +861,6 @@
 !****************************************************************************************
 ! H and Q
-!      print *,'pbl_surface: ok_flux_surf=',ok_flux_surf
-!      print *,'pbl_surface: fsens flat RLVTT=',fsens,flat,RLVTT
+!       print *,'pbl_surface: ok_flux_surf=',ok_flux_surf
+!       print *,'pbl_surface: fsens flat RLVTT=',fsens,flat,RLVTT
        if (ok_flux_surf) then
           y_flux_t1(:) =  fsens
@@ -916,5 +895,5 @@
 !****************************************************************************************
 
-       tke(:,:,nsrf)=0.
+       tke(:,:,nsrf) = 0.
        DO k = 1, klev
           DO j = 1, knon
@@ -922,8 +901,8 @@
              ycoefh(j,k) = ycoefh(j,k) * ypct(j)
              ycoefm(j,k) = ycoefm(j,k) * ypct(j)
-             y_d_t(j,k) = y_d_t(j,k) * ypct(j)
-             y_d_q(j,k) = y_d_q(j,k) * ypct(j)
-             y_d_u(j,k) = y_d_u(j,k) * ypct(j)
-             y_d_v(j,k) = y_d_v(j,k) * ypct(j)
+             y_d_t(j,k)  = y_d_t(j,k) * ypct(j)
+             y_d_q(j,k)  = y_d_q(j,k) * ypct(j)
+             y_d_u(j,k)  = y_d_u(j,k) * ypct(j)
+             y_d_v(j,k)  = y_d_v(j,k) * ypct(j)
 
              flux_t(i,k,nsrf) = y_flux_t(j,k)
@@ -932,5 +911,5 @@
              flux_v(i,k,nsrf) = y_flux_v(j,k)
 
-             tke(i,k,nsrf)=ytke(j,k)
+             tke(i,k,nsrf)    = ytke(j,k)
 
           ENDDO
@@ -1021,9 +1000,11 @@
        trmb2(:,nsrf)  = 0.        ! inhibition 
        trmb3(:,nsrf)  = 0.        ! Point Omega
+       rh2m(:)        = 0.
+       qsat2m(:)      = 0.
 
 #undef T2m     
 #define T2m     
 #ifdef T2m
-! diagnostic t,q a 2m et u, v a 10m
+! Calculations of diagnostic t,q at 2m and u, v at 10m
 
        DO j=1, knon
@@ -1055,13 +1036,26 @@
           i = ni(j)
           t2m(i,nsrf)=yt2m(j)
+          q2m(i,nsrf)=yq2m(j)
           
-          q2m(i,nsrf)=yq2m(j)
-
-! u10m, v10m : composantes du vent a 10m sans spirale de Ekman
+          ! u10m, v10m : composantes du vent a 10m sans spirale de Ekman
           u10m(i,nsrf)=(yu10m(j) * uzon(j))/SQRT(uzon(j)**2+vmer(j)**2)
           v10m(i,nsrf)=(yu10m(j) * vmer(j))/SQRT(uzon(j)**2+vmer(j)**2)
-
        END DO
 
+!IM Calcule de l'humidite relative a 2m (rh2m) pour diagnostique
+!IM Ajoute dependance type surface
+       IF (thermcep) THEN
+          DO j = 1, knon
+             i=ni(j)
+             zdelta1 = MAX(0.,SIGN(1., rtt-yt2m(j) ))
+             zx_qs1  = r2es * FOEEW(yt2m(j),zdelta1)/paprs(i,1)
+             zx_qs1  = MIN(0.5,zx_qs1)
+             zcor1   = 1./(1.-RETV*zx_qs1)
+             zx_qs1  = zx_qs1*zcor1
+             
+             rh2m(i)   = rh2m(i)   + yq2m(j)/zx_qs1 * pctsrf(i,nsrf)
+             qsat2m(i) = qsat2m(i) + zx_qs1  * pctsrf(i,nsrf)
+          END DO
+       END IF
 
        CALL HBTM(knon, ypaprs, ypplay, &
@@ -1086,27 +1080,7 @@
        
 #else 
-! not defined T2m
+! T2m not defined
 ! No calculation
-! Set output variables to zero
-       DO j = 1, knon
-          i = ni(j)
-          pblh(i,nsrf)   = 0.
-          plcl(i,nsrf)   = 0.
-          capCL(i,nsrf)  = 0.
-          oliqCL(i,nsrf) = 0.
-          cteiCL(i,nsrf) = 0.
-          pblT(i,nsrf)   = 0.
-          therm(i,nsrf)  = 0.
-          trmb1(i,nsrf)  = 0.
-          trmb2(i,nsrf)  = 0.
-          trmb3(i,nsrf)  = 0.
-       END DO
-       DO j = 1, knon
-          i = ni(j) 
-          t2m(i,nsrf)=0.
-          q2m(i,nsrf)=0.
-          u10m(i,nsrf)=0.
-          v10m(i,nsrf)=0.
-       END DO
+       PRINT*,' Warning !!! No T2m calculation. Output is set to zero.'
 #endif
 
@@ -1120,6 +1094,4 @@
 ! 16) Calculate the mean value over all sub-surfaces for som variables
 !
-!     NB!!! jg : Pour garder la convergence numerique j'utilise pctsrf_new comme c'etait 
-!     fait dans physiq.F mais ca devrait plutot etre pctsrf???!!!!! A verifier!
 !****************************************************************************************
     
@@ -1129,8 +1101,8 @@
        DO k = 1, klev
           DO i = 1, klon
-             zxfluxt(i,k) = zxfluxt(i,k) + flux_t(i,k,nsrf) * pctsrf_new(i,nsrf)
-             zxfluxq(i,k) = zxfluxq(i,k) + flux_q(i,k,nsrf) * pctsrf_new(i,nsrf)
-             zxfluxu(i,k) = zxfluxu(i,k) + flux_u(i,k,nsrf) * pctsrf_new(i,nsrf)
-             zxfluxv(i,k) = zxfluxv(i,k) + flux_v(i,k,nsrf) * pctsrf_new(i,nsrf)
+             zxfluxt(i,k) = zxfluxt(i,k) + flux_t(i,k,nsrf) * pctsrf(i,nsrf)
+             zxfluxq(i,k) = zxfluxq(i,k) + flux_q(i,k,nsrf) * pctsrf(i,nsrf)
+             zxfluxu(i,k) = zxfluxu(i,k) + flux_u(i,k,nsrf) * pctsrf(i,nsrf)
+             zxfluxv(i,k) = zxfluxv(i,k) + flux_v(i,k,nsrf) * pctsrf(i,nsrf)
           END DO
        END DO
@@ -1143,14 +1115,4 @@
     ENDDO
    
-
-    DO i = 1, klon
-       IF ( ABS( pctsrf_new(i, is_ter) + pctsrf_new(i, is_lic) + &
-            pctsrf_new(i, is_oce) + pctsrf_new(i, is_sic)  - 1.) .GT. EPSFRA) & 
-            THEN 
-          WRITE(*,*) 'physiq : pb sous surface au point ', i, &
-               pctsrf_new(i, 1 : nbsrf)
-       ENDIF
-    ENDDO
-
 !
 ! Incrementer la temperature du sol
@@ -1171,26 +1133,26 @@
           
           wfbils(i,nsrf) = ( solsw(i,nsrf) + sollw(i,nsrf) &
-               + flux_t(i,1,nsrf) + fluxlat(i,nsrf) ) * pctsrf_new(i,nsrf)
+               + flux_t(i,1,nsrf) + fluxlat(i,nsrf) ) * pctsrf(i,nsrf)
           wfbilo(i,nsrf) = (evap(i,nsrf) - (rain_f(i) + snow_f(i))) * &
-               pctsrf_new(i,nsrf)
-
-          zxtsol(i)    = zxtsol(i)    + ts(i,nsrf)      * pctsrf_new(i,nsrf)
-          zxfluxlat(i) = zxfluxlat(i) + fluxlat(i,nsrf) * pctsrf_new(i,nsrf)
+               pctsrf(i,nsrf)
+
+          zxtsol(i)    = zxtsol(i)    + ts(i,nsrf)      * pctsrf(i,nsrf)
+          zxfluxlat(i) = zxfluxlat(i) + fluxlat(i,nsrf) * pctsrf(i,nsrf)
           
-          zt2m(i)  = zt2m(i)  + t2m(i,nsrf)  * pctsrf_new(i,nsrf)
-          zq2m(i)  = zq2m(i)  + q2m(i,nsrf)  * pctsrf_new(i,nsrf)
-          zu10m(i) = zu10m(i) + u10m(i,nsrf) * pctsrf_new(i,nsrf)
-          zv10m(i) = zv10m(i) + v10m(i,nsrf) * pctsrf_new(i,nsrf)
-
-          s_pblh(i)   = s_pblh(i)   + pblh(i,nsrf)  * pctsrf_new(i,nsrf)
-          s_plcl(i)   = s_plcl(i)   + plcl(i,nsrf)  * pctsrf_new(i,nsrf)
-          s_capCL(i)  = s_capCL(i)  + capCL(i,nsrf) * pctsrf_new(i,nsrf)
-          s_oliqCL(i) = s_oliqCL(i) + oliqCL(i,nsrf)* pctsrf_new(i,nsrf)
-          s_cteiCL(i) = s_cteiCL(i) + cteiCL(i,nsrf)* pctsrf_new(i,nsrf)
-          s_pblT(i)   = s_pblT(i)   + pblT(i,nsrf)  * pctsrf_new(i,nsrf)
-          s_therm(i)  = s_therm(i)  + therm(i,nsrf) * pctsrf_new(i,nsrf)
-          s_trmb1(i)  = s_trmb1(i)  + trmb1(i,nsrf) * pctsrf_new(i,nsrf)
-          s_trmb2(i)  = s_trmb2(i)  + trmb2(i,nsrf) * pctsrf_new(i,nsrf)
-          s_trmb3(i)  = s_trmb3(i)  + trmb3(i,nsrf) * pctsrf_new(i,nsrf)
+          zt2m(i)  = zt2m(i)  + t2m(i,nsrf)  * pctsrf(i,nsrf)
+          zq2m(i)  = zq2m(i)  + q2m(i,nsrf)  * pctsrf(i,nsrf)
+          zu10m(i) = zu10m(i) + u10m(i,nsrf) * pctsrf(i,nsrf)
+          zv10m(i) = zv10m(i) + v10m(i,nsrf) * pctsrf(i,nsrf)
+
+          s_pblh(i)   = s_pblh(i)   + pblh(i,nsrf)  * pctsrf(i,nsrf)
+          s_plcl(i)   = s_plcl(i)   + plcl(i,nsrf)  * pctsrf(i,nsrf)
+          s_capCL(i)  = s_capCL(i)  + capCL(i,nsrf) * pctsrf(i,nsrf)
+          s_oliqCL(i) = s_oliqCL(i) + oliqCL(i,nsrf)* pctsrf(i,nsrf)
+          s_cteiCL(i) = s_cteiCL(i) + cteiCL(i,nsrf)* pctsrf(i,nsrf)
+          s_pblT(i)   = s_pblT(i)   + pblT(i,nsrf)  * pctsrf(i,nsrf)
+          s_therm(i)  = s_therm(i)  + therm(i,nsrf) * pctsrf(i,nsrf)
+          s_trmb1(i)  = s_trmb1(i)  + trmb1(i,nsrf) * pctsrf(i,nsrf)
+          s_trmb2(i)  = s_trmb2(i)  + trmb2(i,nsrf) * pctsrf(i,nsrf)
+          s_trmb3(i)  = s_trmb3(i)  + trmb3(i,nsrf) * pctsrf(i,nsrf)
        END DO
     END DO
@@ -1205,31 +1167,31 @@
        PRINT*,' debut apres d_ts min max ftsol(ts)',itap,amn,amx
     ENDIF
-!
-! If a sub-surface does not exsist for a grid point, the mean value for all 
-! sub-surfaces is distributed.
-!
-    DO nsrf = 1, nbsrf
-       DO i = 1, klon
-          IF ((pctsrf_new(i,nsrf) .LT. epsfra) .OR. (t2m(i,nsrf).EQ.0.)) THEN
-             ts(i,nsrf)     = zxtsol(i)
-             t2m(i,nsrf)    = zt2m(i)
-             q2m(i,nsrf)    = zq2m(i)
-             u10m(i,nsrf)   = zu10m(i)
-             v10m(i,nsrf)   = zv10m(i)
-
-! Les variables qui suivent sont plus utilise, donc peut-etre pas la peine a les mettre ajour
-             pblh(i,nsrf)   = s_pblh(i)
-             plcl(i,nsrf)   = s_plcl(i)
-             capCL(i,nsrf)  = s_capCL(i)
-             oliqCL(i,nsrf) = s_oliqCL(i) 
-             cteiCL(i,nsrf) = s_cteiCL(i)
-             pblT(i,nsrf)   = s_pblT(i)
-             therm(i,nsrf)  = s_therm(i)
-             trmb1(i,nsrf)  = s_trmb1(i)
-             trmb2(i,nsrf)  = s_trmb2(i)
-             trmb3(i,nsrf)  = s_trmb3(i)
-          ENDIF
-       ENDDO
-    ENDDO
+!!$!
+!!$! If a sub-surface does not exsist for a grid point, the mean value for all 
+!!$! sub-surfaces is distributed.
+!!$!
+!!$    DO nsrf = 1, nbsrf
+!!$       DO i = 1, klon
+!!$          IF ((pctsrf_new(i,nsrf) .LT. epsfra) .OR. (t2m(i,nsrf).EQ.0.)) THEN
+!!$             ts(i,nsrf)     = zxtsol(i)
+!!$             t2m(i,nsrf)    = zt2m(i)
+!!$             q2m(i,nsrf)    = zq2m(i)
+!!$             u10m(i,nsrf)   = zu10m(i)
+!!$             v10m(i,nsrf)   = zv10m(i)
+!!$
+!!$! Les variables qui suivent sont plus utilise, donc peut-etre pas la peine a les mettre ajour
+!!$             pblh(i,nsrf)   = s_pblh(i)
+!!$             plcl(i,nsrf)   = s_plcl(i)
+!!$             capCL(i,nsrf)  = s_capCL(i)
+!!$             oliqCL(i,nsrf) = s_oliqCL(i) 
+!!$             cteiCL(i,nsrf) = s_cteiCL(i)
+!!$             pblT(i,nsrf)   = s_pblT(i)
+!!$             therm(i,nsrf)  = s_therm(i)
+!!$             trmb1(i,nsrf)  = s_trmb1(i)
+!!$             trmb2(i,nsrf)  = s_trmb2(i)
+!!$             trmb3(i,nsrf)  = s_trmb3(i)
+!!$          ENDIF
+!!$       ENDDO
+!!$    ENDDO
 
 
@@ -1242,32 +1204,9 @@
     DO nsrf = 1, nbsrf
        DO i = 1, klon
-          zxqsurf(i) = zxqsurf(i) + qsurf(i,nsrf) * pctsrf_new(i,nsrf)
-          zxsnow(i)  = zxsnow(i)  + snow(i,nsrf)  * pctsrf_new(i,nsrf)
+          zxqsurf(i) = zxqsurf(i) + qsurf(i,nsrf) * pctsrf(i,nsrf)
+          zxsnow(i)  = zxsnow(i)  + snow(i,nsrf)  * pctsrf(i,nsrf)
        END DO
     END DO
 
-!
-!IM Calculer l'humidite relative a 2m (rh2m) pour diagnostique
-!IM ajout dependance type surface
-    rh2m(:)   = 0.0
-    qsat2m(:) = 0.0
-
-    DO i = 1, klon
-       DO nsrf=1, nbsrf
-          zx_t1(i,nsrf) = t2m(i,nsrf)
-          IF (thermcep) THEN
-             zdelta1(i,nsrf) = MAX(0.,SIGN(1.,rtt-zx_t1(i,nsrf)))
-             zx_qs1(i,nsrf)  = r2es * &
-                  FOEEW(zx_t1(i,nsrf),zdelta1(i,nsrf))/paprs(i,1)
-             zx_qs1(i,nsrf)  = MIN(0.5,zx_qs1(i,nsrf))
-             zcor1(i,nsrf)   = 1./(1.-retv*zx_qs1(i,nsrf))
-             zx_qs1(i,nsrf)  = zx_qs1(i,nsrf)*zcor1(i,nsrf)
-          END IF
-          zx_rh2m(i,nsrf) = q2m(i,nsrf)/zx_qs1(i,nsrf)
-          zx_qsat2m(i,nsrf)=zx_qs1(i,nsrf)
-          rh2m(i) = rh2m(i)+zx_rh2m(i,nsrf)*pctsrf_new(i,nsrf)
-          qsat2m(i)=qsat2m(i)+zx_qsat2m(i,nsrf)*pctsrf_new(i,nsrf)
-       END DO
-    END DO
 
 ! Some of the module declared variables are returned for printing in physiq.F
@@ -1322,5 +1261,111 @@
 !  
 !****************************************************************************************
+! 
+  SUBROUTINE pbl_surface_newfrac(itime, pctsrf_new, pctsrf_old, tsurf, alb1, alb2, u10m, v10m, tke)
+
+    ! Give default values where new fraction has appread
+
+    INCLUDE "indicesol.h"
+    INCLUDE "dimsoil.h"
+    INCLUDE "clesphys.h"
+
+! Input variables
+!****************************************************************************************
+    INTEGER, INTENT(IN)                     :: itime
+    REAL, DIMENSION(klon,nbsrf), INTENT(IN) :: pctsrf_new, pctsrf_old
+
+! InOutput variables
+!****************************************************************************************
+    REAL, DIMENSION(klon,nbsrf), INTENT(INOUT)        :: tsurf
+    REAL, DIMENSION(klon,nbsrf), INTENT(INOUT)        :: alb1, alb2
+    REAL, DIMENSION(klon,nbsrf), INTENT(INOUT)        :: u10m, v10m
+    REAL, DIMENSION(klon,klev+1,nbsrf), INTENT(INOUT) :: tke
+
+! Local variables
+!****************************************************************************************
+    INTEGER           :: nsrf, nsrf_comp1, nsrf_comp2, nsrf_comp3, i
+    CHARACTER(len=80) :: abort_message
+    CHARACTER(len=20) :: modname = 'pbl_surface_newfrac'
+    INTEGER, DIMENSION(nbsrf) :: nfois=0, mfois=0, pfois=0
+    LOGICAL           :: debug=.FALSE.
+!
+! All at once !! 
+!****************************************************************************************
+    
+    DO nsrf = 1, nbsrf
+       ! First decide complement sub-surfaces
+       SELECT CASE (nsrf)
+       CASE(is_oce)
+          nsrf_comp1=is_sic
+          nsrf_comp2=is_ter
+          nsrf_comp3=is_lic
+       CASE(is_sic)
+          nsrf_comp1=is_oce
+          nsrf_comp2=is_ter
+          nsrf_comp3=is_lic
+       CASE(is_ter)
+          nsrf_comp1=is_lic
+          nsrf_comp2=is_oce
+          nsrf_comp3=is_sic
+       CASE(is_lic)
+          nsrf_comp1=is_ter
+          nsrf_comp2=is_oce
+          nsrf_comp3=is_sic
+       END SELECT
+
+       ! Initialize all new fractions
+       DO i=1, klon
+          IF (pctsrf_new(i,nsrf) > 0. .AND. pctsrf_old(i,nsrf) == 0.) THEN
+
+             IF (pctsrf_old(i,nsrf_comp1) > 0.) THEN
+                ! Use the complement sub-surface, keeping the continents unchanged
+                qsurf(i,nsrf) = qsurf(i,nsrf_comp1)
+                evap(i,nsrf)  = evap(i,nsrf_comp1)
+                rugos(i,nsrf) = rugos(i,nsrf_comp1)
+                tsurf(i,nsrf) = tsurf(i,nsrf_comp1)
+                alb1(i,nsrf)  = alb1(i,nsrf_comp1)
+                alb2(i,nsrf)  = alb2(i,nsrf_comp1)
+                u10m(i,nsrf)  = u10m(i,nsrf_comp1)
+                v10m(i,nsrf)  = v10m(i,nsrf_comp1)
+                tke(i,:,nsrf) = tke(i,:,nsrf_comp1)
+                mfois(nsrf) = mfois(nsrf) + 1
+             ELSE
+                ! The continents have changed. The new fraction receives the mean sum of the existent fractions
+                qsurf(i,nsrf) = qsurf(i,nsrf_comp2)*pctsrf_old(i,nsrf_comp2) + qsurf(i,nsrf_comp3)*pctsrf_old(i,nsrf_comp3)
+                evap(i,nsrf)  = evap(i,nsrf_comp2) *pctsrf_old(i,nsrf_comp2) + evap(i,nsrf_comp3) *pctsrf_old(i,nsrf_comp3)
+                rugos(i,nsrf) = rugos(i,nsrf_comp2)*pctsrf_old(i,nsrf_comp2) + rugos(i,nsrf_comp3)*pctsrf_old(i,nsrf_comp3)
+                tsurf(i,nsrf) = tsurf(i,nsrf_comp2)*pctsrf_old(i,nsrf_comp2) + tsurf(i,nsrf_comp3)*pctsrf_old(i,nsrf_comp3)
+                alb1(i,nsrf)  = alb1(i,nsrf_comp2) *pctsrf_old(i,nsrf_comp2) + alb1(i,nsrf_comp3) *pctsrf_old(i,nsrf_comp3)
+                alb2(i,nsrf)  = alb2(i,nsrf_comp2) *pctsrf_old(i,nsrf_comp2) + alb2(i,nsrf_comp3) *pctsrf_old(i,nsrf_comp3)
+                u10m(i,nsrf)  = u10m(i,nsrf_comp2) *pctsrf_old(i,nsrf_comp2) + u10m(i,nsrf_comp3) *pctsrf_old(i,nsrf_comp3)
+                v10m(i,nsrf)  = v10m(i,nsrf_comp2) *pctsrf_old(i,nsrf_comp2) + v10m(i,nsrf_comp3) *pctsrf_old(i,nsrf_comp3)
+                tke(i,:,nsrf) = tke(i,:,nsrf_comp2)*pctsrf_old(i,nsrf_comp2) + tke(i,:,nsrf_comp3)*pctsrf_old(i,nsrf_comp3)
+            
+                ! Security abort. This option has never been tested. To test, comment the following line.
+!                abort_message='The fraction of the continents have changed!'
+!                CALL abort_gcm(modname,abort_message,1)
+                nfois(nsrf) = nfois(nsrf) + 1
+             END IF
+             snow(i,nsrf)     = 0.
+             agesno(i,nsrf)   = 0.
+             ftsoil(i,:,nsrf) = tsurf(i,nsrf)
+          ELSE
+             pfois(nsrf) = pfois(nsrf)+ 1
+          END IF
+       END DO
+       
+    END DO
+
+    IF (debug) THEN
+       print*,'itime=,',itime, 'Pas de nouveau fraction',pfois,'fois'
+       print*,'itime=,',itime, 'The fraction of the continents have changed',nfois,'fois'
+       print*,'itime=,',itime, 'The fraction ocean-seaice has changed',mfois,'fois'
+    END IF
+
+  END SUBROUTINE pbl_surface_newfrac
+
 !  
+!****************************************************************************************
+!  
 
 END MODULE pbl_surface_mod
Index: LMDZ4/trunk/libf/phylmd/phyetat0.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/phyetat0.F	(revision 993)
+++ LMDZ4/trunk/libf/phylmd/phyetat0.F	(revision 996)
@@ -5,5 +5,4 @@
 c
       SUBROUTINE phyetat0 (fichnom,
-     .           ocean_in, ok_veget_in,
      .           clesphy0,
      .           tabcntr0)
@@ -13,10 +12,8 @@
       USE mod_phys_lmdz_para
       USE iophy
-      USE ocean_slab_mod,   ONLY : ocean_slab_init
       USE ocean_cpl_mod,    ONLY : ocean_cpl_init
-      USE ocean_forced_mod, ONLY : ocean_forced_init
       USE fonte_neige_mod,  ONLY : fonte_neige_init
       USE pbl_surface_mod,  ONLY : pbl_surface_init
-      USE surface_data,     ONLY : ocean, ok_veget
+      USE surface_data,     ONLY : type_ocean
       USE phys_state_var_mod
 
@@ -68,5 +65,4 @@
       REAL wake_fip_glo(klon_glo)
       REAL tsoil_p(klon,nsoilmx,nbsrf)
-      REAL tslab_p(klon), seaice_p(klon)
       REAL qsurf_p(klon,nbsrf)
       REAL qsol_p(klon)
@@ -83,6 +79,4 @@
       REAL zmasq_glo(klon_glo)
       REAL tsoil(klon_glo,nsoilmx,nbsrf)
-cIM "slab" ocean
-      REAL tslab(klon_glo), seaice(klon_glo)
       REAL qsurf(klon_glo,nbsrf)
       REAL qsol(klon_glo)
@@ -492,60 +486,4 @@
       ENDDO
       ENDDO
-c
-cIM "slab" ocean 
-c
-c Lecture de tslab (pour slab ocean seulement):      
-c
-      IF (ocean_in .eq. 'slab  ') then
-        ierr = NF_INQ_VARID (nid, "TSLAB", nvarid)
-        IF (ierr.NE.NF_NOERR) THEN
-          PRINT*, "phyetat0: Le champ <TSLAB> est absent"
-          CALL abort
-        ENDIF
-#ifdef NC_DOUBLE
-        ierr = NF_GET_VAR_DOUBLE(nid, nvarid, tslab)
-#else
-        ierr = NF_GET_VAR_REAL(nid, nvarid, tslab)
-#endif
-        IF (ierr.NE.NF_NOERR) THEN
-          PRINT*, "phyetat0: Lecture echouee pour <TSLAB>"
-          CALL abort
-        ENDIF
-        xmin = 1.0E+20
-        xmax = -1.0E+20
-        DO i = 1, klon_glo
-          xmin = MIN(tslab(i),xmin)
-          xmax = MAX(tslab(i),xmax)
-        ENDDO
-        PRINT*,'Min, Max tslab (utilise si OCEAN=slab )', xmin, xmax
-c
-c Lecture de seaice (pour slab ocean seulement):
-c
-        ierr = NF_INQ_VARID (nid, "SEAICE", nvarid)
-        IF (ierr.NE.NF_NOERR) THEN
-          PRINT*, "phyetat0: Le champ <SEAICE> est absent"
-          CALL abort
-        ENDIF
-#ifdef NC_DOUBLE
-        ierr = NF_GET_VAR_DOUBLE(nid, nvarid, seaice)
-#else
-        ierr = NF_GET_VAR_REAL(nid, nvarid, seaice)
-#endif
-        IF (ierr.NE.NF_NOERR) THEN
-          PRINT*, "phyetat0: Lecture echouee pour <SEAICE>"
-          CALL abort
-        ENDIF
-        xmin = 1.0E+20
-        xmax = -1.0E+20
-        DO i = 1, klon_glo
-          xmin = MIN(seaice(i),xmin)
-          xmax = MAX(seaice(i),xmax)
-        ENDDO
-        PRINT*,'Masse de la glace de mer (utilise si OCEAN=slab)', 
-     $  xmin, xmax
-      ELSE
-        tslab = 0.
-        seaice = 0.
-      ENDIF
 c
 c Lecture de l'humidite de l'air juste au dessus du sol:
@@ -1762,6 +1700,4 @@
       call Scatter( wake_fip_glo, wake_fip)
       call Scatter( tsoil,tsoil_p)
-      call Scatter( tslab,tslab_p)
-      call Scatter( seaice,seaice_p)
       call Scatter( qsurf,qsurf_p)
       call Scatter( qsol,qsol_p)
@@ -1796,9 +1732,4 @@
 
 c
-c Initilalize variables in module surface_data
-c
-      ok_veget = ok_veget_in
-      ocean    = ocean_in
-c
 c Initialize module pbl_surface_mod 
 c
@@ -1806,14 +1737,7 @@
      $     evap_p, frugs_p, agesno_p, tsoil_p)
 
-c Initialize ocean module according to ocean type
-      IF ( ocean == 'slab' ) THEN
-c        initilalize module ocean_slab_init
-         CALL ocean_slab_init(dtime, tslab_p, seaice_p, pctsrf)
-      ELSEIF ( ocean == 'couple' ) THEN
-c        initilalize module ocean_cpl_init
+c Initialize module ocean_cpl_mod for the case of coupled ocean
+      IF ( type_ocean == 'couple' ) THEN
          CALL ocean_cpl_init(dtime, rlon, rlat)
-      ELSE
-c        initilalize module ocean_forced_init
-         CALL ocean_forced_init
       ENDIF
 c
Index: LMDZ4/trunk/libf/phylmd/phyredem.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/phyredem.F	(revision 993)
+++ LMDZ4/trunk/libf/phylmd/phyredem.F	(revision 996)
@@ -8,8 +8,6 @@
       USE mod_grid_phy_lmdz
       USE mod_phys_lmdz_para
-      USE ocean_slab_mod,   ONLY : ocean_slab_final
       USE fonte_neige_mod,  ONLY : fonte_neige_final
       USE pbl_surface_mod,  ONLY : pbl_surface_final
-      USE surface_data,     ONLY : ocean, ok_veget
       USE phys_state_var_mod
 
@@ -60,7 +58,5 @@
       REAL wake_fip_glo(klon_glo)
 
-cIM "slab" ocean
       REAL tsoil_p(klon,nsoilmx,nbsrf)
-      REAL tslab_p(klon), seaice_p(klon)
       REAL qsurf_p(klon,nbsrf)
       REAL qsol_p(klon)
@@ -73,5 +69,4 @@
       
       REAL tsoil(klon_glo,nsoilmx,nbsrf)
-      REAL tslab(klon_glo), seaice(klon_glo)
       REAL qsurf(klon_glo,nbsrf)
       REAL qsol(klon_glo)
@@ -103,12 +98,4 @@
 c Get a variable calculated in module fonte_neige_mod
       CALL fonte_neige_final(run_off_lic_0_p)
-
-c If slab ocean then get 2 varaibles from module ocean_slab_mod
-      IF ( ocean == 'slab' ) THEN
-         CALL ocean_slab_final(tslab_p, seaice_p)
-      ELSE 
-         tslab_p(:)  = 0.0
-         seaice_p(:) = 0.0
-      ENDIF      
 
 c======================================================================
@@ -150,6 +137,4 @@
 
       call Gather( tsoil_p,tsoil)
-      call Gather( tslab_p,tslab)
-      call Gather( seaice_p,seaice)
       call Gather( qsurf_p,qsurf)
       call Gather( qsol_p,qsol)
@@ -390,35 +375,4 @@
       ENDDO
 c
-cIM "slab" ocean
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "TSLAB", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "TSLAB", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 33,
-     .                        "Ecart de la SST (pour slab-ocean)")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,tslab)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,tslab)
-#endif
-c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "SEAICE", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "SEAICE", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 33,
-     .                        "Glace de mer kg/m2 (pour slab-ocean)")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,seaice)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,seaice)
-#endif
-c
       DO nsrf = 1, nbsrf
         IF (nsrf.LE.99) THEN
